// Modificat de la font: https://www.sparkfun.com/products/10167
// Copyleft (2015): Carles Ferrando Garcia
// License: GNU GPL V3 https://www.gnu.org/licenses/gpl.html
#include <dht.h>
dht DHT;
#define DHT22_PIN 5
#include <Time.h>  

//Definim temperatura i humitat relativa reals mesurades pel sensor RHT03
float temperatura; // T en ºC
float humitat; // Humitat relativa %
float TF ; //T en ºF

//Definim els valors de heat index de la NOAA
float c1= -42.379 ;
float c2= 2.04901523;
float c3= 10.14333127;
float c4= -0.22475541;
float c5= -0.00683783;
float c6= -0.05481717;
float c7= 0.00122874;
float c8= 0.00085282;
float c9= -0.00000199;
float HI ; // heat index in ºF

//Definim la temperatura de xafogor
float Txaf ; // en ºC

//Definim la data i hora per configurar el rellotge
int hora;
int minut;
int segon;
int dia;
int mes;
int any;



void setup()
{
    Serial.begin(9600);
    //setTime(hr,min,sec,day,month,yr); // CAL POSAR L-HORA REAL I LA DATA AL COMENÇAR LA CLASSE A LA RATLLA DE SOTA
    setTime(16,44,00,12,8,2015); //  CAL POSAR L-HORA REAL I LA DATA AL COMENÇAR LA CLASSE
}
void loop()
{
    // Llegeix les dades
   int chk = DHT.read22(DHT22_PIN);
   
   // Actualitza l_hora a partir de l_hora configurada al setTime
   time_t t = now(); 
   hora = hour(t);
   minut= minute(t);
   segon= second(t);
   dia = day(t);
   mes= month(t);
   any= year(t);
  
    // Mostra les el lloc , la data i les dades de temperatura i humitat
    Serial.println(" ");
    Serial.println("IES A_B_C Aula a_b_c ");//CAL CANVIAR EL LLOC I POSAR L-AULA ON FAS LA CLASSE
    Serial.print("Hui es el ");
    Serial.print(dia);
    Serial.print(" del ");
    Serial.print(mes);
    Serial.print(" de ");
    Serial.print(any);
    Serial.print(" i son les ");
    Serial.print(hora);
    Serial.print(" : ");
    Serial.print(minut); 
    Serial.print(" : ");
    Serial.println(segon); 
    humitat=DHT.humidity ;
    Serial.print(" Humitat (%) = ");
    Serial.print( humitat);
    Serial.print(",\t");
    temperatura= DHT.temperature;
    Serial.print("Temperatura (C) = ");
    Serial.print(temperatura);

TF = (temperatura * 1.8)+32 ; 
HI= c1 + (c2*TF) + (c3*humitat) + (c4*TF*humitat) + (c5*TF*TF) + (c6*humitat*humitat) + (c7*TF*TF*humitat) + (c8*TF*humitat*humitat) + (c9*TF*TF*humitat*humitat) ;
Txaf=((HI-32)/1.8);

    Serial.print(",\t");
    Serial.print("T de xafogor (C)=");
    Serial.println(Txaf);
    Serial.println(" ");

if(Txaf > 27 and Txaf < 32) { //Es dona un avis de precaucio
  Serial.println(" Precaucio amb la fatiga si fas activitats fisiques");
}//final del condicional 1

if(Txaf > 32 and Txaf < 41) { //Es dona un avis de precaucio extrema
  Serial.println(" Extrema la precaucio amb la fatiga si fas activitats fisiques.");
  Serial.println(" Es posible una rampa per calor o un colp de calor.");
}//final del condicional 2

if(Txaf > 41 and Txaf < 54) { //Es dona un avis de perill
  Serial.println(" Atencio: Perill. Un colp de calor es probable si continues en aquest ambient");
  Serial.println(" Prem alguna beguda fesqueta i fes un descans.");
}//final del condicional 3

if(Txaf > 54) { //Si el calor supera la temeparura de xafogor de 54 ºC abandonem el aula
  Serial.println(" Estas en risc extrem de tindre una insolacio per calor. ");
  Serial.println(" Cal abandonar l_aula de forma ordenada i beure aigua ");
  Serial.println(" Fes una captura de pantalla per enviar a inspeccio de treball a itvalencia@meyss.es i salvar el teu cul. ");
}//final del condicional 4

delay (3000); //Aturem el programa 3 segons i tornem a fer una altra lectura

}//Comença un nou cicle.
